// Nastavenie Mriežky účiaria
// (c) JP, verzia 2015.02.27
//
if (app.documents.length==0) { 
 alert("Nie je otvorený žiaden dokument!");
 exit();
}
var Dokument=app.activeDocument;  
//Odpamätanie pôvodných nastavení pravítok
var PovodnaXJednotka=Dokument.viewPreferences.horizontalMeasurementUnits;
var PovodnaYJednotka=Dokument.viewPreferences.verticalMeasurementUnits;
//Nastavenie pravítok na pt
Dokument.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
Dokument.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
//Aktuálne nastavenie mriežky účiaria
var MriezkaUciaria=Dokument.gridPreferences.baselineDivision;
var Zaciatok=Dokument.gridPreferences.baselineStart;
// Odpamätáme si terajšie nastavenie bodov na palec, napr. 67.564 (Didot)
var BodyNaPalec=Dokument.viewPreferences.pointsPerInch;
// nastavíme interný počet 72 bodov na palec
Dokument.viewPreferences.pointsPerInch=72; 

var DialogMriezkaUciaria=app.dialogs.add({name:"Nastavenie mriežky účiaria"});
with(DialogMriezkaUciaria.dialogColumns.add()){
 with (dialogRows.add()){
  with(dialogColumns.add()){
   with(borderPanels.add()){
    with (dialogColumns.add()){  
     staticTexts.add({staticLabel:"Mriežka účiaria:"});
     staticTexts.add({staticLabel:"Začiatok:"});
    }
    with (dialogColumns.add()){
     var VelkostMriezky=measurementEditboxes.add({editValue:MriezkaUciaria, editUnits:MeasurementUnits.POINTS});
     var PrvyRiadok=measurementEditboxes.add({editValue:Zaciatok, editUnits:MeasurementUnits.POINTS});
    }
   }
  }
 }
}
var dialogOK=DialogMriezkaUciaria.show();
MriezkaUciaria=VelkostMriezky.editValue;
Zaciatok=PrvyRiadok.editValue;
DialogMriezkaUciaria.destroy();
//Pôvodné body na palec 
Dokument.viewPreferences.pointsPerInch=BodyNaPalec;
if (dialogOK==false) {
 //Nastavenie pôvodných pravítok
 Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka; 
 exit();
}
//Výpočet počtu riadkov v obrazci
var Strana=Dokument.pages[0];
var VelkostStrany=Strana.bounds;
var VyskaObrazca=VelkostStrany[2]-VelkostStrany[0]-Strana.marginPreferences.top-Strana.marginPreferences.bottom-Zaciatok; //Výška obrazca (strana mínus okraje mínus posun prvého riadku)
var RiadkovReal=VyskaObrazca/MriezkaUciaria; //Počet riadkov v obrazci (reálne číslo)
//Zaokrúhlený počet riadkov v obrazci 
var Riadkov1=Math.round(RiadkovReal);
var Riadkov2=Riadkov1+1; //Bude zaokruhlene, viac, realne
if (RiadkovReal<Riadkov1) {
 Riadkov2=Riadkov1-1; //Bude zaokruhlene, menej, realne
}
var Riadkov3=RiadkovReal;
if (RiadkovReal==Riadkov1) {
 Riadkov3=Riadkov1-1; //Bude realne, viac, menej
}

//Výpočet mriežky podľa počtu riadkov
var Mriezka1=VyskaObrazca/Riadkov1;
var Mriezka2=VyskaObrazca/Riadkov2;
var Mriezka3=VyskaObrazca/Riadkov3;
var DialogMriezkaUciaria=app.dialogs.add({name:"Nastavenie mriežky účiaria"});
with(DialogMriezkaUciaria.dialogColumns.add()){
 with(dialogRows.add()){
  with(dialogColumns.add()){
   staticTexts.add({staticLabel:"Nastaviť v:"});
  }
  with(dialogColumns.add()){
   with(borderPanels.add()){
    with(dialogColumns.add()){
     var NastavID=checkboxControls.add({staticLabel:"Globálne v InDesign", checkedState:false});
     var NastavDokument=checkboxControls.add({staticLabel:"V aktuálnom dokumente", checkedState:true});
    }
   }
  }
 }
 with(dialogRows.add()){
  with(dialogColumns.add()){
   staticTexts.add({staticLabel:"Mriežka účiaria:"});
  }
  var MoznostiMriezky = radiobuttonGroups.add();
  with(MoznostiMriezky){
   radiobuttonControls.add({staticLabel:Riadkov1+" riadkov ("+Mriezka1+" bodov)", checkedState:true});
   radiobuttonControls.add({staticLabel:Riadkov2+" riadkov ("+Mriezka2+" bodov)", checkedState:false});
   radiobuttonControls.add({staticLabel:Riadkov3+" riadkov ("+Mriezka3+" bodov)", checkedState:false});
  }
 }
}
var dialogOK=DialogMriezkaUciaria.show();
if (dialogOK==true) {
 switch(MoznostiMriezky.selectedButton){
  case 0:
   MriezkaUciaria=Mriezka1;
   break;
  case 1:
   MriezkaUciaria=Mriezka2;
   break;
  case 2:
   MriezkaUciaria=Mriezka3;
   break; 
 }
 var nastavene=false;
 if (NastavDokument.checkedState==true) {
  with(Dokument.gridPreferences){ 
   baselineGridRelativeOption=BaselineGridRelativeOption.TOP_OF_MARGIN_OF_BASELINE_GRID_RELATIVE_OPTION; //Mriežka účiaria bude začínať na sadzobom obrazci 
   baselineStart=Zaciatok;
   baselineDivision=MriezkaUciaria;
   baselineShown=true;
   nastavene=true;
  }
 }
 if (NastavID.checkedState==true) {
  //Odpamätanie pôvodných nastavení pravítok
  var PovodnaXIDJednotka=app.viewPreferences.horizontalMeasurementUnits;
  var PovodnaYIDJednotka=app.viewPreferences.verticalMeasurementUnits;
  //Nastavenie pravítok na pt
  app.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
  app.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS; 
  with(app.gridPreferences){ 
   baselineGridRelativeOption=BaselineGridRelativeOption.TOP_OF_MARGIN_OF_BASELINE_GRID_RELATIVE_OPTION; //Mriežka účiaria bude začínať na sadzobom obrazci 
   baselineStart=Zaciatok;
   baselineDivision=MriezkaUciaria;
   baselineShown=true;
   nastavene=true;
  }
  //Nastavenie pôvodných pravítok
  app.viewPreferences.horizontalMeasurementUnits=PovodnaXIDJednotka;
  app.viewPreferences.verticalMeasurementUnits=PovodnaYIDJednotka; 
 }
 if (nastavene==true) {
  alert('Nastavená mriežka účiaria '+MriezkaUciaria+' bodov.');
 }
}
DialogMriezkaUciaria.destroy();
//Nastavenie pôvodných pravítok
Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
